<?php
// $Id: _gen_default_wrappers.php,v 1.1.2.1 2005/12/28 08:45:04 tclineks Exp $

/**
 * @file
 *   procedurally generates default_wrappers.php
 *
 *   i.e. `php -q _gen_default_wrappers.php > default_wrappers.php`
 *   (the -q parameter skips output of http headers) 
 */

// set wrapper types
$types = array('functions','modifiers');

// set to list of functions for which to generate generic wrappers
$wrappers['functions'] = array(
  'l',
  't',
  'theme',
  'url',
  'variable_get',
  );

// set to list of modifiers for which to generate generic wrappers
$wrappers['modifiers'] = array(
  't',
  );

// generic wrapper name prefixes
$prefix['functions'] = '_wrapper_func_';
$prefix['modifiers'] = '_wrapper_mod_';

// do it
echo <<<END
<?php
// \$Id
END;
echo <<<END
$

/**
 * @file
 *   Defines default drupal functions to make available for Smarty templates
 *   as either functions or modifiers.
 */


END;

foreach ($types as $type) {
  echo <<<END

function _get_default_{$type}() {
  return array(

END;

  foreach ($wrappers[$type] as $wrapper)
    echo "    '$wrapper' => '$prefix[$type]$wrapper',\n";
    echo "  );
}

";
}

foreach ($types as $type) {
  foreach ($wrappers[$type] as $wrapper)
    echo "function $prefix[$type]$wrapper(\$params) { return call_user_func_array('$wrapper', \$params); }\n";
  echo "\n";
}

echo "\n?>\n";
?>
