<?php
// $Id: common.php,v 1.1.2.1 2005/12/28 08:45:04 tclineks Exp $

/**
 * @file
 *   Common functions for Smarty theme engine
 *
 * @author
 *   tclineks - Travis Cline (travis dot cline at gmail dot com)
 * @license
 *   http://www.gnu.org/copyleft/gpl.html Licensed under GPL
 */

if (!defined('ENGINE_PATH')) {
  define('ENGINE_PATH', 'themes/engines/smarty');
}

/**
 * Will display an error if 'themes/engines/smarty/templates_c' directory is not writable
 * by the web server process.
 */
function _test_permissions($plainhtml = false) {
  $path = ENGINE_PATH.'/templates_c';
  $_readable = !is_readable($path);
  $_writable = !is_writable($path);
  $_retval = $_readable | ($_writable * 2);

  $_problems = $_readable ? 'readable' : '';
  if ($_writable) {
    $_problems .= $_readable ? ' OR writable' : 'writable';
  }

  $_message = t("Smarty Permissions Error: templates_c directory is not <strong> %problems </strong> by the web server process.<br />
    You <strong>must</strong> resolve this issue before you begin to use a Smarty-based theme.
    See <a href=\"http://drupal.org/project/smarty\">drupal.org/project/smarty</a> for instructions.", array('%problems' => $_problems));

  if ($_retval > 0) {
    if ($plainhtml) {
	  echo $_message;
	}
    else { 
	  drupal_set_message($_message, 'error');
	}
  }
  return $_retval;
}

?>
